System.usbDiskModeActivate()

math.randomseed(os.time())
playertotal = 0
dealertotal = 0
topcard = 5
playernext = 3
dealernext = 3
exit = false
playerace = false
dealerace=false

--Images
card_back = Image.load("Images/back.png")
background = Image.load("Images/background.png")
Spade = Image.load("Images/Spades.png")
Diamond = Image.load("Images/Diamonds.png")
Heart = Image.load("Images/Hearts.png")
Club = Image.load("Images/Clubs.png")

--Arrays for figuring out what card the player has
card_values = { 2, 3, 4, 5, 6, 7, 8, 9, 10, 10, 10, 10, 11, 2, 3, 4, 5, 6, 7, 8, 9, 10, 10, 10, 10, 11, 2, 3, 4, 5, 6, 7, 8, 9, 10, 10, 10, 10, 11, 2, 3, 4, 5, 6, 7, 8, 9, 10, 10, 10, 10, 11 }
card_suit = { "D", "D", "D", "D", "D", "D", "D", "D", "D", "D", "D", "D", "D", "S", "S", "S", "S", "S", "S", "S", "S", "S", "S", "S", "S", "S", "H", "H", "H", "H", "H", "H", "H", "H", "H", "H", "H", "H", "H", "C", "C", "C", "C", "C", "C", "C", "C", "C", "C", "C", "C", "C" }
player_hand = {}
dealer_hand = {}
deck = {}

function shuffle()
	x = 1
	while x < 53 do
		deck[x] = x
		x = x + 1
	end

	cnt = 0
	while cnt < 10 do
		x = 1
		while x < 52 do
			rand =  math.random(52)
			temp = deck[x]
			deck[x] = deck[rand]
			deck[rand] = temp
			x = x + 1
		end
		cnt = cnt + 1
	end
end

function initdeal()
	player_hand[1] = deck[1]
	player_hand[2] = deck[2]
	dealer_hand[1] = deck[3]
	dealer_hand[2] = deck[4]
	playertotal = card_values[player_hand[1]] + card_values[player_hand[2]]
	dealertotal = card_values[dealer_hand[1]] + card_values[dealer_hand[2]]
	
	if card_values[player_hand[1]] == 11 then
		playerace = true
	end
	
	if card_values[player_hand[2]] == 11 then
		playerace = true
	end

	if card_values[dealer_hand[1]] == 11 then
		dealerace = true
	end
	
	if card_values[dealer_hand[2]] == 11 then
		dealerace = true
	end

	--Draw Player Cards
	x = 1 
	while x < 3 do
		--screen:blit(37,92,Spade,0,0,36,Spade:height(), false)
		
		if card_suit[player_hand[x]]=='S' then
			screen:blit((37+((x-1)*43)), 92, Spade,(player_hand[x] - 14)*36, 0, 36, Spade:height(), false)			
		end
		
		if card_suit[player_hand[x]]=='D' then
			screen:blit((37+((x-1)*43)), 92, Diamond, (player_hand[x] - 1)*36, 0, 36, Diamond:height(), false)
		end
		
		if card_suit[player_hand[x]]=='H' then
			screen:blit((37+((x-1)*43)), 92, Heart, (player_hand[x] - 27)*36, 0, 36, Heart:height(), false)
		else		
		--if card_suit[dealer_hand[x]]=='C' then
			screen:blit((37+((x-1)*43)), 92, Club, (player_hand[x] - 40)*36, 0, 36, Club:height(), false)
		end
		x = x + 1
	end
	
	--Draw Dealer Cards
 	screen:blit(37, 183, card_back, 0, 0, card_back:width(), card_back:height(), false)
 	
 	if card_suit[dealer_hand[2]]=='S' then
		screen:blit(80, 183, Spade,(dealer_hand[2] - 14)*36, 0, 36, Spade:height(), false)			
	end
		
	if card_suit[dealer_hand[2]]=='D' then
		screen:blit(80, 183, Diamond, (dealer_hand[2] - 1)*36, 0, 36, Diamond:height(), false)
	end
		
	if card_suit[dealer_hand[2]]=='H' then
		screen:blit(80, 183, Heart, (dealer_hand[2] - 27)*36, 0, 36, Heart:height(), false)
	end
		
	if card_suit[dealer_hand[2]]=='C' then
		screen:blit(80, 183, Club, (dealer_hand[2] - 40)*36, 0, 36, Club:height(), false)
	end
 	
	screen:print(300,100,"L - Hit", white)
	screen:print(300,110,"R - Stay", white)
	screen.waitVblankStart()
	screen.flip()
	screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false)
end


function playerinput()
	
	while 1==1 do
		if Controls.read():l() then
			
			player_hand[playernext] = deck[topcard]
			playertotal = playertotal + card_values[player_hand[playernext]]
			if card_values[player_hand[playernext]] == 11 then
				playerace = true
			end
			
			screen.flip()
			if card_suit[player_hand[playernext]]=='S' then
				screen:blit((37+((playernext-1)*43)), 92, Spade,(player_hand[playernext] - 14)*36, 0, 36, Spade:height(), false)			
			end
		
			if card_suit[player_hand[playernext]]=='D' then
				screen:blit((37+((playernext-1)*43)), 92, Diamond, (player_hand[playernext] - 1)*36, 0, 36, Diamond:height(), false)
			end
		
			if card_suit[player_hand[playernext]]=='H' then
				screen:blit((37+((playernext-1)*43)), 92, Heart, (player_hand[playernext] - 27)*36, 0, 36, Heart:height(), false)
			else		
			--if card_suit[player_hand[x]]=='C' then
				screen:blit((37+((playernext-1)*43)), 92, Club, (player_hand[playernext] - 40)*36, 0, 36, Club:height(), false)
			end
			
			screen.flip()
			topcard = topcard + 1
			playernext = playernext + 1
			
			if playertotal > 21 then
				if playerace == true then
					playertotal = playertotal-10
					playerace = false
				else
					Bust()
					break
				end
			end	
			System.sleep(500) 
		end

		if Controls.read():r() then
			break
		end

		if Controls.read():start() then
			exit = true
			break
		end
	end
end


function dealerinput()
	while true do
		if dealertotal < 17 then
			dealer_hand[dealernext] = deck[topcard]
			dealertotal = dealertotal + card_values[dealer_hand[dealernext]]
			if card_values[dealer_hand[dealernext]] == 11 then
				dealerace = true
			end		
	
			screen.flip()
			if card_suit[dealer_hand[dealernext]]=='S' then
				screen:blit((37+((dealernext-1)*43)), 183, Spade,(dealer_hand[dealernext] - 14)*36, 0, 36, Spade:height(), false)			
			end
		
			if card_suit[dealer_hand[dealernext]]=='D' then
				screen:blit((37+((dealernext-1)*43)), 183, Diamond, (dealer_hand[dealernext] - 1)*36, 0, 36, Diamond:height(), false)
			end
		
			if card_suit[dealer_hand[dealernext]]=='H' then
				screen:blit((37+((dealernext-1)*43)), 183, Heart, (dealer_hand[dealernext] - 27)*36, 0, 36, Heart:height(), false)
			end
		
			if card_suit[dealer_hand[dealernext]]=='C' then
				screen:blit((37+((dealernext-1)*43)), 183, Club, (dealer_hand[dealernext] - 40)*36, 0, 36, Club:height(), false)
			end
			
			screen.flip()
			topcard = topcard + 1
			dealernext = dealernext + 1
			
			if dealertotal > 21 then
				if dealerace == true then
					dealertotal = dealertotal-10
					dealerace = false
				else
					Bust()
					break
				end	
			end
			System.sleep(500)
		else
			screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false)
			break
		end
	end
end


function Bust()
	--System.sleep(500)
	screen.flip()
	showdealercard()
	if playertotal > 21 then
		msg = Image.load("Images/playerbust.png")
		screen:blit(140, 100, msg, 0, 0, msg:width(), msg:height(), true)
	else
		msg = Image.load("Images/dealerbust.png")
		screen:blit(140, 100, msg, 0, 0, msg:width(), msg:height(), true)
	end
	screen.flip()
	while 1==1 do
		if Controls.read():cross() then
			screen:flip()
			msg = Image.load("Images/playagain.png")
			screen:blit(140, 100, msg, 0, 0, msg:width(), msg:height(), true)
			screen:flip()
			System.sleep(500)
			break
		end
	end
end


function showdealercard()
			if card_suit[dealer_hand[1]]=='S' then
				screen:blit(37, 183, Spade,(dealer_hand[1] - 14)*36, 0, 36, Spade:height(), false)			
			end
		
			if card_suit[dealer_hand[1]]=='D' then
				screen:blit(37, 183, Diamond, (dealer_hand[1] - 1)*36, 0, 36, Diamond:height(), false)
			end
		
			if card_suit[dealer_hand[1]]=='H' then
				screen:blit(37, 183, Heart, (dealer_hand[1] - 27)*36, 0, 36, Heart:height(), false)
			end
		
			if card_suit[dealer_hand[1]]=='C' then
				screen:blit(37, 183, Club, (dealer_hand[1] - 40)*36, 0, 36, Club:height(), false)
			end
end

function checkscores()
	screen:flip()
	showdealercard()
	if playertotal > dealertotal then
		msg = Image.load("Images/playerwin.png")
		screen:blit(140, 100, msg, 0, 0, msg:width(), msg:height(), true)
	end

	if playertotal < dealertotal then
		msg = Image.load("Images/dealerwin.png")
		screen:blit(140, 100, msg, 0, 0, msg:width(), msg:height(), true)
	end

	if playertotal == dealertotal then
		msg = Image.load("Images/tie.png")
		screen:blit(140, 100, msg, 0, 0, msg:width(), msg:height(), true)
	end
	screen:flip()
	while 1==1 do
		if Controls.read():cross() then
			screen:flip()
			msg = Image.load("Images/playagain.png")
			screen:blit(140, 100, msg, 0, 0, msg:width(), msg:height(), true)
			screen:flip()
			System.sleep(500)
			break
		end
	end
end
	


function main()
 	screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false)
	shuffle()
	initdeal()
	playerinput()
	screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false)
	if exit == false then
		if playertotal < 22 then
			dealerinput()
			if dealertotal < 22 then
				checkscores()
			end
		end
	end
	
end




white = Color.new(255, 255, 255)
black = Color.new(0, 0, 0)
screen:clear(black)

main()
while true do
	if exit == true then
		break
	end
	if Controls.read():cross() then break end
	if Controls.read():circle() then 
		screen:flip()
		topcard = 5
		playernext = 3
		dealernext = 3
		playerace = false
		dealerace = false
		dealertotal = 0
		playertotal = 0
		main()
	end
end
